--
-- AnimatiiMobile
--
-- @autor Mihai94
--07/02/2013
--
AnimatiiMobile = {};

function AnimatiiMobile.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function AnimatiiMobile:load(xmlFile)
	local PipaNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Pipa#index"));
    if PipaNode ~= nil then
        self.Pipa = {};
        self.Pipa.node = PipaNode;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Pipa#minRot"));
        self.Pipa.minRot = {};
        self.Pipa.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Pipa.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Pipa.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Pipa#maxRot"));
        self.Pipa.maxRot = {};
        self.Pipa.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Pipa.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Pipa.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Pipa.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Pipa#rotTime"), 200);
        self.Pipa.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.Pipa#touchRotLimit"), 10));
    end;

    local UsaNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Usa#index"));
    if UsaNode ~= nil then
        self.Usa = {};
        self.Usa.node = UsaNode;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Usa#minRot"));
        self.Usa.minRot = {};
        self.Usa.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Usa.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Usa.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Usa#maxRot"));
        self.Usa.maxRot = {};
        self.Usa.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Usa.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Usa.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Usa.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Usa#rotTime"), 200);
        self.Usa.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.Usa#touchRotLimit"), 10));
    end;

    local GeamDreaptaNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.GeamDreapta#index"));
    if GeamDreaptaNode ~= nil then
        self.GeamDreapta = {};
        self.GeamDreapta.node = GeamDreaptaNode;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.GeamDreapta#minRot"));
        self.GeamDreapta.minRot = {};
        self.GeamDreapta.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.GeamDreapta.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.GeamDreapta.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.GeamDreapta#maxRot"));
        self.GeamDreapta.maxRot = {};
        self.GeamDreapta.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.GeamDreapta.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.GeamDreapta.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.GeamDreapta.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.GeamDreapta#rotTime"), 200);
        self.GeamDreapta.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.GeamDreapta#touchRotLimit"), 10));
    end;

    local AparatoareFuliiNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.AparatoareFulii#index"));
    if AparatoareFuliiNode ~= nil then
        self.AparatoareFulii = {};
        self.AparatoareFulii.node = AparatoareFuliiNode;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.AparatoareFulii#minRot"));
        self.AparatoareFulii.minRot = {};
        self.AparatoareFulii.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.AparatoareFulii.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.AparatoareFulii.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.AparatoareFulii#maxRot"));
        self.AparatoareFulii.maxRot = {};
        self.AparatoareFulii.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.AparatoareFulii.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.AparatoareFulii.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.AparatoareFulii.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.AparatoareFulii#rotTime"), 200);
        self.AparatoareFulii.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.AparatoareFulii#touchRotLimit"), 10));
    end;
  
    local CapacBuncarNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.CapacBuncar#index"));
    if CapacBuncarNode ~= nil then
        self.CapacBuncar = {};
        self.CapacBuncar.node = CapacBuncarNode;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.CapacBuncar#minRot"));
        self.CapacBuncar.minRot = {};
        self.CapacBuncar.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.CapacBuncar.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.CapacBuncar.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.CapacBuncar#maxRot"));
        self.CapacBuncar.maxRot = {};
        self.CapacBuncar.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.CapacBuncar.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.CapacBuncar.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.CapacBuncar.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.CapacBuncar#rotTime"), 200);
        self.CapacBuncar.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.CapacBuncar#touchRotLimit"), 10));
    end;

end;
function AnimatiiMobile:delete()

end;

function AnimatiiMobile:mouseEvent(posX, posY, isDown, isUp, button)

end;

function AnimatiiMobile:keyEvent(unicode, sym, modifier, isDown)

end;

function AnimatiiMobile:update(dt)

if self.inrange or self.isEntered then

	if InputBinding.hasEvent (InputBinding.DeschidePipa) then
		self.openPipa = not self.openPipa;
	end;

     if InputBinding.hasEvent (InputBinding.DeschideUsa) then
		self.openUsa = not self.openUsa;
	end;

     if InputBinding.hasEvent (InputBinding.DeschideGeamDreapta) then
		self.openGeamDreapta = not self.openGeamDreapta;
	end;

     if InputBinding.hasEvent (InputBinding.DeschideAparatoareFulii) then
		self.openAparatoareFulii = not self.openAparatoareFulii;
	end;

    if InputBinding.hasEvent (InputBinding.DeschideCapacBuncar) then
		self.openCapacBuncar = not self.openCapacBuncar;
	end;
end;

	if self.inrange or self.isEntered then
		if self.openPipa then
			g_currentMission:addExtraPrintText(string.format("Taste %s: Inchide Pipa", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschidePipa)));
		else
			g_currentMission:addExtraPrintText(string.format("Taste %s: Deschide Pipa", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschidePipa)));
		end;
	end; 

     if self.inrange or self.isEntered then
		if self.openUsa then
			g_currentMission:addExtraPrintText(string.format("Taste %s: Inchide Usa", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideUsa)));
		else
			g_currentMission:addExtraPrintText(string.format("Taste %s: Deschide Usa", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideUsa)));
		end;
	end; 

     if self.inrange or self.isEntered then
		if self.openGeamDreapta then
			g_currentMission:addExtraPrintText(string.format("Taste %s: Inchide GeamDreapta", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideGeamDreapta)));
		else
			g_currentMission:addExtraPrintText(string.format("Taste %s: Deschide GeamDreapta", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideGeamDreapta)));
		end;
	end; 

    if self.inrange or self.isEntered then
		if self.openAparatoareFulii then
			g_currentMission:addExtraPrintText(string.format("Taste %s: Inchide AparatoareFulii", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideAparatoareFulii)));
		else
			g_currentMission:addExtraPrintText(string.format("Taste %s: Deschide AparatoareFulii", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideAparatoareFulii)));
		end;
	end;

       if self.inrange or self.isEntered then
		if self.openCapacBuncar then
			g_currentMission:addExtraPrintText(string.format("Taste %s: Inchide CapacBuncar", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideCapacBuncar)));
		else
			g_currentMission:addExtraPrintText(string.format("Taste %s: Deschide CapacBuncar", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideCapacBuncar)));
		end;
	end; 


	if self.Pipa ~= nil then
		local x, y, z = getRotation(self.Pipa.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.Pipa.minRot, self.Pipa.maxRot, 3, self.Pipa.rotTime, dt, self.openPipa);
		setRotation(self.Pipa.node, unpack(newRot));
	end;

     if self.Usa ~= nil then
		local x, y, z = getRotation(self.Usa.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.Usa.minRot, self.Usa.maxRot, 3, self.Usa.rotTime, dt, self.openUsa);
		setRotation(self.Usa.node, unpack(newRot));
	end;
    
       if self.GeamDreapta ~= nil then
		local x, y, z = getRotation(self.GeamDreapta.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.GeamDreapta.minRot, self.GeamDreapta.maxRot, 3, self.GeamDreapta.rotTime, dt, self.openGeamDreapta);
		setRotation(self.GeamDreapta.node, unpack(newRot));
	end;

     if self.AparatoareFulii ~= nil then
		local x, y, z = getRotation(self.AparatoareFulii.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.AparatoareFulii.minRot, self.AparatoareFulii.maxRot, 3, self.AparatoareFulii.rotTime, dt, self.openAparatoareFulii);
		setRotation(self.AparatoareFulii.node, unpack(newRot));
	end;

     if self.CapacBuncar ~= nil then
		local x, y, z = getRotation(self.CapacBuncar.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.CapacBuncar.minRot, self.CapacBuncar.maxRot, 3, self.CapacBuncar.rotTime, dt, self.openCapacBuncar);
		setRotation(self.CapacBuncar.node, unpack(newRot));
	end;
end;

function AnimatiiMobile:updateTick(dt)
if g_currentMission.player ~= nil then
		-- Getting the distance between the player and the implement 
		local nearestDistance = 4.0; --max distance allowed
		local px, py, pz = getWorldTranslation(self.rootNode); 
		local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);	
		if distance < nearestDistance then
			self.inrange = true; 
		else
			self.inrange = false; 
		end;
	end;
end;

function AnimatiiMobile:draw()  

end;

function AnimatiiMobile:onLeave()

end;




